/*ʵ:PWMʵ
 *    :SmartMCU
 *޸:2012/4/5
 *    :www.smartmcu.com
 *    :http://smartmcu.taobao.com/
 *˵    :ע뽲ARM Cortex-M0ԭʵպѧ
*/
#include "SmartM_M0.h"

#define EN_EXT_OSC			    0


#define COMPLEMENT_MODE         0x00000020
#define DEAD_ZONE_INTERVAL      0xC8FF0000
#define PWM_ENABLE              0x01010101 
 
#if     EN_EXT_OSC
#define PWM_CLOCK_SOURCE        0x00000000	 //ʹⲿ12MHz
#else  
#define PWM_CLOCK_SOURCE        0xF0000000	 //ʹڲRC22.1184MHz
#endif

#define PWM_PRESCALAE           0x0000C731	 //PWM01ԤƵ0x31(49)PWM23ԤƵ0xC7(199)
#define PWM_CLOCK_DIVIDER       0x00004444	 //ʱӷƵ1
#define PWM_OUTPUT_INVERT       0x00040000
#define PWM_OUTPUT_ENABLE       0x0000000F   //PWM0123ʹ

#define PWM_CMR_VALUE			0x0
#define PWM_CNR_VALUE 		    0x1000	     //4096

/*
PWMƵ=PWMxy_CLK/(prescale+1)*(clock divider)/(CNR+1)


(1)ʹⲿ12MHz
PWMƵ=12000000/(49+1)*4097
       =58.57Hz
(2)ʹڲRC22.1184MHz

PWMƵ=22118400/(49+1)*4097
       =107.97Hz
*/

#define LED_DARKING             0
#define LED_BRIGHTING			1

STATIC UINT32 g_unPWMCMRValue=PWM_CNR_VALUE;
STATIC UINT32 g_unLedStat=LED_DARKING;



/****************************************
*:PWMInit
*    :
*    :
*    :PWMʼ
******************************************/
VOID PWMInit(VOID)
{
    P2_MFP &= ~(P20_AD8_PWM0 |
			   	P21_AD9_PWM1 |
			   	P22_AD10_PWM2|
			   	P23_AD11_PWM3);
	P2_MFP |= (PWM0 | PWM1 | PWM2 | PWM3);	  //ʹP2.0~P2.3ΪPWM
   
    P2_PMD &= ~Px0_PMD;                       //P2.0~P2.3Ϊ
	P2_PMD |= Px0_OUT;

	P2_PMD &= ~Px1_PMD;
	P2_PMD |= Px1_OUT;

	P2_PMD &= ~Px2_PMD;
	P2_PMD |= Px2_OUT;

	P2_PMD &= ~Px3_PMD;
	P2_PMD |= Px3_OUT;

    APBCLK |= PWM01_CLKEN|
			  PWM23_CLKEN;                                      //ʹPWM0~3ʱ
	CLKSEL1 = PWM_CLOCK_SOURCE;           						//ѡPWM0~3ʱԴ
    
	PPRA = PWM_PRESCALAE | DEAD_ZONE_INTERVAL;                  //ѡPWM0~3ʱԤƵ
    CSRA = PWM_CLOCK_DIVIDER;                                   //ѡPWM0~3ʱӷƵ
    PCRA = 0x08080808 | PWM_OUTPUT_INVERT | COMPLEMENT_MODE;    //PWM0~3Զװ

    CNR0A = CNR1A = CNR2A = CNR3A = PWM_CNR_VALUE;              //PWM0~3ֵ
    CMR0A = CMR1A = CMR2A = CMR3A = PWM_CMR_VALUE;              //PWM0~3Ƚֵ


    PIERA  |= PWMIE3 |                                          //ʹPWM0~3ж
   			  PWMIE2 |
			  PWMIE1 |
			  PWMIE0 ;	
    NVIC_ISER |= PWMA_INT;                                      //ʹPWM0~3ж

    POEA = PWM_OUTPUT_ENABLE;                                   //PWMʹ
    PCRA |= PWM_ENABLE;                                         //PWMʹܣ

}

/****************************************
*:main
*    :
*    :
*    :
******************************************/
INT32 main(VOID)
{

 	 PROTECT_REG								                 //ISPʱFLASH洢
	 (
		 PWRCON |= XTL12M_EN;						             //ĬʱԴΪⲿ
		 while((CLKSTATUS & XTL12M_STB) == 0); 		             //ȴ12MHzʱȶ	
		
		 CLKSEL0 = (CLKSEL0 & (~HCLK)) | HCLK_12M;	             //ⲿΪϵͳʱ
	
		 PWMInit();	 											 //PWMʼ
	 )						

     while(1);
}

/****************************************
*:PWMA_IRQHandler
*    :
*    :
*    :жϷ-PWMA
******************************************/
VOID PWMA_IRQHandler(VOID)
{
	 switch(g_unLedStat)						      //LED״̬
	 {
	 	case  LED_DARKING:							  //LED״̬
		{
			 if(g_unPWMCMRValue < PWM_CNR_VALUE)
			 {
			 	g_unPWMCMRValue+=50;
			 }
			 else
			 {
			    g_unLedStat = LED_BRIGHTING;

			 	g_unPWMCMRValue=PWM_CNR_VALUE;
			 }		
		}break;

		case  LED_BRIGHTING:						   //LED״̬
		{
			 if(g_unPWMCMRValue>=50)
			 {
			 	g_unPWMCMRValue-=50;
			 }
			 else
			 {
			    g_unLedStat = LED_DARKING;

			 	g_unPWMCMRValue=PWM_CMR_VALUE;			 
			 }
		}break;

		default:break;
	 
	 }

	 CMR0A = CMR1A = CMR2A = CMR3A = g_unPWMCMRValue;  //PWM0~3Ƚֵ

     PIIRA = PIIRA;                           
}

